"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mongodb_1 = require("mongodb");
var mongo_entity_1 = require("./mongo_entity");
var db = null;
var name = '';
var host = '127.0.0.1';
var port = '27017';
var disposeTimeout = 200;
var disconnectTimeoutId = null;
var serverTimeoutId = null;
var initContext = null;
var testServer;
var alwaysStopServer = true;
var verbose = false;
function config(_a) {
    var mongoHost = _a.mongoHost, mongoPort = _a.mongoPort, mongoDisposeTimeout = _a.mongoDisposeTimeout, ic = _a.initContext, ts = _a.testServer, ass = _a.alwaysStopServer, vb = _a.verbose;
    host = mongoHost || host;
    port = mongoPort || port;
    disposeTimeout = mongoDisposeTimeout || disposeTimeout;
    initContext = ic || initContext;
    testServer = ts || testServer;
    alwaysStopServer = ass || alwaysStopServer;
    verbose = vb || verbose;
}
exports.config = config;
function getDb() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (db) {
                        return [2 /*return*/, db];
                    }
                    name = "tmp" + Math.floor(Math.random() * 10000);
                    if (verbose) {
                        console.log('New connection to ' + name);
                    }
                    return [4 /*yield*/, mongodb_1.MongoClient.connect("mongodb://" + host + ":" + port + "/" + name)];
                case 1:
                    db = _a.sent();
                    global.db = db;
                    return [2 /*return*/, db];
            }
        });
    });
}
exports.getDb = getDb;
function withEntity(test, options) {
    return __awaiter(this, void 0, void 0, function () {
        var connector, entities, i, option, name_1, type, entity, _i, _a, data, ex_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (disconnectTimeoutId != null) {
                        clearTimeout(disconnectTimeoutId);
                    }
                    return [4 /*yield*/, getConnector()];
                case 1:
                    connector = _b.sent();
                    entities = [];
                    if (!(options && options.entities)) return [3 /*break*/, 8];
                    i = 0;
                    _b.label = 2;
                case 2:
                    if (!(i < options.entities.length)) return [3 /*break*/, 7];
                    option = options.entities[i];
                    name_1 = option.name;
                    type = option.type ? option.type : mongo_entity_1.default;
                    entity = new type(connector, name_1 ? name_1 : "test_" + i);
                    entities.push(entity);
                    if (!options.entities[i].data) return [3 /*break*/, 6];
                    _i = 0, _a = options.entities[i].data;
                    _b.label = 3;
                case 3:
                    if (!(_i < _a.length)) return [3 /*break*/, 6];
                    data = _a[_i];
                    return [4 /*yield*/, entity.insertOne(data)];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 3];
                case 6:
                    i++;
                    return [3 /*break*/, 2];
                case 7: return [3 /*break*/, 9];
                case 8:
                    entities.push(new mongo_entity_1.default(connector, 'test'));
                    _b.label = 9;
                case 9:
                    _b.trys.push([9, 11, 12, 14]);
                    return [4 /*yield*/, test.apply(void 0, entities)];
                case 10:
                    _b.sent();
                    return [3 /*break*/, 14];
                case 11:
                    ex_1 = _b.sent();
                    throw ex_1;
                case 12: return [4 /*yield*/, entities.forEach(function (e) { return e.deleteMany({}); })];
                case 13:
                    _b.sent();
                    disposeDb();
                    return [7 /*endfinally*/];
                case 14: return [2 /*return*/];
            }
        });
    });
}
exports.withEntity = withEntity;
function itWithEntity(name, func, options) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, withEntity(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, func(context)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        }); }); }, options)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    });
}
exports.itWithEntity = itWithEntity;
var fakeConnector = {
    collection: function () {
        return {
            deleteMany: function () { },
            insert: function () { },
            find: function () { },
            findOne: function () { }
        };
    }
};
function withContext(test, initContextFn, disconnected) {
    if (disconnected === void 0) { disconnected = false; }
    return __awaiter(this, void 0, void 0, function () {
        var connector, _a, context, ex_2, _i, _b, key;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (disconnectTimeoutId != null) {
                        clearTimeout(disconnectTimeoutId);
                    }
                    if (!disconnected) return [3 /*break*/, 1];
                    _a = fakeConnector;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, getConnector()];
                case 2:
                    _a = _c.sent();
                    _c.label = 3;
                case 3:
                    connector = _a;
                    initContext = initContextFn || initContext;
                    if (!initContext) {
                        throw new Error('No initContext provided, please pass as a parameter or use global config');
                    }
                    context = initContext(connector);
                    _c.label = 4;
                case 4:
                    _c.trys.push([4, 6, 7, 12]);
                    return [4 /*yield*/, test(context)];
                case 5:
                    _c.sent();
                    return [3 /*break*/, 12];
                case 6:
                    ex_2 = _c.sent();
                    throw ex_2;
                case 7:
                    _i = 0, _b = Object.keys(context);
                    _c.label = 8;
                case 8:
                    if (!(_i < _b.length)) return [3 /*break*/, 11];
                    key = _b[_i];
                    if (!(context[key] && context[key].dispose)) return [3 /*break*/, 10];
                    return [4 /*yield*/, context[key].dispose({}, true)];
                case 9:
                    _c.sent();
                    _c.label = 10;
                case 10:
                    _i++;
                    return [3 /*break*/, 8];
                case 11:
                    disposeDb();
                    return [7 /*endfinally*/];
                case 12: return [2 /*return*/];
            }
        });
    });
}
exports.withContext = withContext;
function itWithContext(name, func, initContextFn, disconnected) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, withContext(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, func(context)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        }); }); }, initContextFn, disconnected)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    });
}
exports.itWithContext = itWithContext;
function withServer(test, server) {
    return __awaiter(this, void 0, void 0, function () {
        var ex_3, _i, _a, key;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (serverTimeoutId != null) {
                        clearTimeout(serverTimeoutId);
                    }
                    if (server) {
                        if (verbose) {
                            console.log('Using local server');
                        }
                        testServer = server;
                    }
                    else {
                        if (verbose) {
                            console.log('Using global server');
                        }
                        server = testServer;
                    }
                    if (!server) {
                        throw new Error('No server provided, please pass as a parameter or use global config');
                    }
                    if (!!server.started) return [3 /*break*/, 2];
                    return [4 /*yield*/, server.startTest()];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, 5, 10]);
                    return [4 /*yield*/, test(server)];
                case 3:
                    _b.sent();
                    return [3 /*break*/, 10];
                case 4:
                    ex_3 = _b.sent();
                    throw ex_3;
                case 5:
                    _i = 0, _a = Object.keys(server.context);
                    _b.label = 6;
                case 6:
                    if (!(_i < _a.length)) return [3 /*break*/, 9];
                    key = _a[_i];
                    if (!(server.context[key] && server.context[key].dispose)) return [3 /*break*/, 8];
                    return [4 /*yield*/, server.context[key].dispose({}, true)];
                case 7:
                    _b.sent();
                    _b.label = 8;
                case 8:
                    _i++;
                    return [3 /*break*/, 6];
                case 9:
                    disposeServer();
                    return [7 /*endfinally*/];
                case 10: return [2 /*return*/];
            }
        });
    });
}
exports.withServer = withServer;
function itWithServer(name, func, server) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, withServer(function (context) {
                            return __awaiter(this, void 0, void 0, function () { return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, func(context)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            }); });
                        }, server)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    });
}
exports.itWithServer = itWithServer;
function getConnector() {
    return __awaiter(this, void 0, void 0, function () {
        var myDb;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getDb()];
                case 1:
                    myDb = _a.sent();
                    return [2 /*return*/, {
                            collection: function (name) {
                                return db.collection(name);
                            }
                        }];
            }
        });
    });
}
exports.getConnector = getConnector;
function dropDatabase() {
    return __awaiter(this, void 0, void 0, function () {
        var myDb;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    myDb = db;
                    db = null;
                    if (!myDb) return [3 /*break*/, 3];
                    if (verbose) {
                        console.log('tearing down db');
                    }
                    return [4 /*yield*/, myDb.dropDatabase()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, myDb.close()];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function stopServer() {
    if (testServer) {
        if (verbose) {
            console.log('Stopping test server');
        }
        testServer.stopTest();
    }
}
exports.stopServer = stopServer;
function disposeDb(immediate) {
    if (immediate === void 0) { immediate = false; }
    if (immediate) {
        dropDatabase();
    }
    disconnectTimeoutId = setTimeout(dropDatabase, disposeTimeout);
}
exports.disposeDb = disposeDb;
function disposeServer(immediate) {
    if (immediate === void 0) { immediate = false; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (immediate || alwaysStopServer) {
                stopServer();
            }
            else {
                serverTimeoutId = setTimeout(stopServer, disposeTimeout);
            }
            return [2 /*return*/];
        });
    });
}
exports.disposeServer = disposeServer;
